use barrel::backend::Sqlite;
use barrel::{types, types::Type, Migration};

fn primary_uuid() -> Type {
    types::text().unique(true).primary(true).nullable(false)
}

pub fn migration() -> String {
    // sqlite does really support alter column, and barrel does not
    // implement the required workaround, so we do it ourselves!
    r#"
      CREATE TABLE IF NOT EXISTS "accounts2" (
         "user_id" TEXT PRIMARY KEY NOT NULL UNIQUE,
         "password" TEXT NULL
      );
      INSERT INTO accounts2 select * from accounts;
      DROP TABLE accounts;
      ALTER TABLE accounts2 RENAME TO accounts;
    "#
    .to_string()
}
